#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vip_core>
#include <clientprefs>

#define SHOW_MODE	1

static const char MDL[][] =
{
	"materials/ggwp/effects/black.vmt",
	"materials/ggwp/effects/black.vmt"
};

public Plugin:myinfo =
{
	name = "[VIP] Halo Black/ Чёрный Нимб",
	author = "R1KO & Pheonix (˙·٠●Феникс●٠·˙), (rewritten Nek.'a 2x2)",
	version = "1.1",
	url = "zizt.ru"
};

#define VIP_HALO_BLACK				"HALO_BLACK"
new VIP_ToggleState:g_bHasAura[MAXPLAYERS+1];
new Handle:g_hTimer[MAXPLAYERS+1];
new g_BeamSprite, g_HaloSprite;

public OnMapStart() 
{
	AddFileToDownloadsTable(MDL[0]);
	AddFileToDownloadsTable(MDL[1]);
	black_prec();
}

black_prec()
{
	g_BeamSprite = PrecacheModel("materials/ggwp/effects/black.vmt", true);
	g_HaloSprite = PrecacheModel("materials/ggwp/effects/black.vmt", true);
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_HALO_BLACK, BOOL, _, ToggleItemCallback, OnDisplayItem_f);
}

public VIP_OnVIPClientLoaded(iClient)
{
	if(VIP_IsClientFeatureUse(iClient, VIP_HALO_BLACK))
	{
		g_bHasAura[iClient] = ENABLED;
	}
}

public Action:ToggleItemCallback(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	g_bHasAura[iClient] = NewStatus;
	if(NewStatus == ENABLED) SetClientAura(iClient);
	return Plugin_Continue;
}

public bool:OnDisplayItem_f(iClient, const String:sFeatureName[], String:sDisplay[], maxlen)
{
	FormatEx(sDisplay, maxlen, "Чёрный Нимб [%s]", VIP_IsClientFeatureUse(iClient, VIP_HALO_BLACK) ? "Включено":"Выключено");
	return true;
}

public OnClientDisconnect(iClient)
{
	g_bHasAura[iClient] = DISABLED;
	g_hTimer[iClient] = INVALID_HANDLE;
}

public VIP_OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && g_bHasAura[iClient])
	{
		SetClientAura(iClient);
	}
}

SetClientAura(iClient)
{
	if(g_hTimer[iClient] == INVALID_HANDLE) g_hTimer[iClient] = CreateTimer(0.1, Timer_Beacon, iClient, TIMER_REPEAT);
}

public Action:Timer_Beacon(Handle:hTimer, any:iClient)
{
	if(IsClientInGame(iClient) && IsPlayerAlive(iClient) && g_bHasAura[iClient] == ENABLED)
	{
		static Float:fVec[3];
		GetClientAbsOrigin(iClient, fVec);
		fVec[2] += 85;
		TE_SetupBeamRingPoint(fVec, 15.0, 17.0, g_BeamSprite, g_HaloSprite, 0, 15, 0.1, 1.0, 0.0, {255, 255, 255, 255}, 10, 0);
			#if SHOW_MODE == 0
			static iClients[1], iCount = 1;
			iClients[0] = iClient;
			#else
			static iClients[MAXPLAYERS], iCount, i;
			iCount = 0;
			#if SHOW_MODE == 1
			new iTeam = GetClientTeam(iClient);
			#endif
			for(i = 1; i <= MaxClients; ++i)
			{
				if(IsClientInGame(i) && !IsFakeClient(i))
				{
					#if SHOW_MODE == 1
					if(GetClientTeam(i) != iTeam)
					{
						continue;
					}
					#endif
					
					iClients[iCount++] = i;
				}
			}
		#endif
		TE_SendToAll();
		return Plugin_Continue;
	} 
	else
	{
		g_hTimer[iClient] = INVALID_HANDLE;
	}
	return Plugin_Stop;
}